# The given code can detect the presence of intermediary hosts
# in the incoming FTP commands by monitoring the IPT values
# of requests.

@load ftp

	const proxy_file = open_log_file("proxy") &redef;
	global rtt: interval;
	global rtt_cond: interval;
	const rtt_threshold = 1.2 sec;
# Event generated by Bro when a ftp request is received from ftp client
event ftp_request(c: connection, command: string, arg: string)
	{
	local request = arg == "" ? command : cat(command, " ", arg);
	rtt = connection_rtt(c$id);
		if (rtt > .05sec)
			rtt_cond = rtt*1.25;
		else
			rtt_cond = rtt*2;		
	local id = c$id;
	local session = FTP::ftp_sessions[id];
	session$request = request;
	++session$num_req;
	session$request_t = network_time();		
	if ((session$request_t - session$last_request_t) > rtt_cond && (session$request_t - session$last_request_t) < rtt_threshold)
		session$sum = session$sum + (session$request_t - session$last_request_t);
	if ((session$num_req > 4) && (session$sum/session$num_req) > rtt_cond && !session$alarmp)
		{
		print proxy_file, fmt("%.6f #%s Proxy Connection: %s",
			network_time(), prefixed_id(session$id), id_string(c$id));
		session$alarmp = T;
		}
	session$last_request_t = network_time();
	}


