# The code below can detect the presence of a proxybots
# by monitoring the IPT values of incoming SMTP requests.

@load smtp

	const proxy_file = open_log_file("proxy") &redef;
	global rtt: interval;
	global rtt_cond: interval;
# Event generated by Bro IDS when a SMTP request is received from client
event smtp_request(c: connection, is_orig: bool, command: string, arg: string)
	{
	local request = arg == "" ? command : cat(command, " ", arg);
	rtt = connection_rtt(c$id);
	if (rtt > .05sec)
		rtt_cond = rtt*1.25;
	else
		rtt_cond = rtt*2;
	local id = c$id;
	local session = SMTP::smtp_sessions[id];		
	if(session$origin_h == id$orig_h)
		++session$num_req;
	session$request_t = network_time();		
	if ((session$request_t - session$last_request_t) > rtt_cond)
		session$sum = session$sum + (session$request_t - session$last_request_t);
	if ((session$num_req > 4) && (session$sum/(session$num_req)) > rtt_cond && !session$alarmp)
		{
		print proxy_file, fmt("%.6f #%s Proxy Connection: %s ", network_time(), prefixed_id(session$id), id_string(c$id));
		session$alarmp = T;
		}
	session$last_request_t = network_time();
	}
